@isTest
private class TestGRDDashboardHome
{
    public static Database.saveResult createBusinessDept(String counter)
    {
        // Business Department
        Business_Department__c dept = new Business_Department__c(Name = 'Dept '+counter);
        Database.saveResult deptResult = Database.insert(dept);
        return deptResult;
    }
    
    public static Database.saveResult createDistrict(String counter, Database.saveResult businessDept)
    {
        // Operating District
        Operating_District__c district = new Operating_District__c(Name = 'District '+counter,
                                                                   Business_Department__c = businessDept.getId());
        Database.saveResult districtResult = Database.insert(district);
        return districtResult;
    }
    
    public static Database.saveResult createAMU(String counter, Database.saveResult district)
    {
        Field__c amu = new Field__c(Name = 'AMU '+counter,
                                    Operating_District__c = district.getId());
        Database.saveResult amuResult = Database.insert(amu);
        return amuResult;
    }
    
    public static List<Database.saveResult> createAMUs(Integer num, Integer counter, Database.saveResult district)
    {
        List<Field__c> amus = new List<Field__c>();
        Integer stop = counter+num;
        for(; counter < stop; counter++)
        {
            Field__c amu = new Field__c(Name = 'AMU '+String.valueOf(counter),
                                        Operating_District__c = district.getId());
            amus.add(amu);
        }
        return Database.insert(amus);
    }
    
    public static List<Map<String, Database.saveResult>> createLocations(Integer num, Integer counter, Database.saveResult AMU)
    {
        List<Map<String, Database.saveResult>> allLocations = new List<Map<String, Database.saveResult>>();
        
        List<Location__c> locations = new List<Location__c>();
        Integer stop = counter+num;
        for(; counter < stop; counter++)
        {
            // Surface Location
            Location__c surface = new Location__c(Name                   = 'Surface '+counter,
                                                  Operating_Field_AMU__c = AMU.getId());
            locations.add(surface);
            
            // Target Location
            Location__c target = new Location__c(Name                   = 'Target '+counter,
                                                 Operating_Field_AMU__c = AMU.getId());
            locations.add(target);
            
            // UWI Location
            Location__c uwi = new Location__c(Name                   = 'UWI '+counter,
                                              Operating_Field_AMU__c = AMU.getId());
            locations.add(uwi);
        }
        
        List<Database.saveResult> locationsResult = Database.insert(locations);
        
        for(Integer i = 0; i < locations.size(); i+=3)
        {
            locations[i+1].Well_Id__c = locationsResult[ i ].getId();
            locations[i+2].Well_Id__c = locationsResult[i+1].getId();
            
            Map<String, Database.saveResult> locationTriple = new Map<String, Database.saveResult>();
            locationTriple.put('Surface', locationsResult[ i ]);
            locationTriple.put('Target',  locationsResult[i+1]);
            locationTriple.put('UWI',     locationsResult[i+2]);
            allLocations.add(locationTriple);
        }
        
        update locations;
        
        return allLocations;
    }
    
    public static List<Database.saveResult> createWells(Integer num, Integer counter, Database.saveResult surfaceLocation)
    {
        // GRD Well
        List<GRD_Well__c> wells = new List<GRD_Well__c>();
        
        Integer stop = counter+num;
        for(; counter < stop; counter++)
        {
            GRD_Well__c well = new GRD_Well__c(Name                = 'Well '+counter,
                                               Surface_Location__c = surfaceLocation.getId());
            wells.add(well);
        }
        return Database.insert(wells);
    }
    
    public static List<Database.saveResult> createWells(Integer num, Integer counter, List<Database.saveResult> surfaceLocations)
    {
        // GRD Well
        List<GRD_Well__c> wells = new List<GRD_Well__c>();
        
        for(Integer i = 0; i < surfaceLocations.size(); i++)
        {
            GRD_Well__c well = new GRD_Well__c(Name                = 'Well '+counter,
                                               Surface_Location__c = surfaceLocations[i].getId());
            wells.add(well);
            
            counter++;
        }
        return Database.insert(wells);
    }
    
    public static List<Database.saveResult> createBoreholes(Integer counter, List<Database.saveResult> wells, List<Database.saveResult> targetLocations, List<Database.saveResult> UWILocations)
    {
        // Get GRD's recordtype
        RecordType rt = [SELECT Id FROM RecordType where sobjecttype = 'GRD_Borehole__c' and DeveloperName = 'GRD'];
        
        List<GRD_Borehole__c> boreholes = new List<GRD_Borehole__c>();
        
        for(Integer i = 0; i < wells.size(); i++)
        {
            GRD_Borehole__c bore = new GRD_Borehole__c(Name                           = 'Borehole '+counter,
                                                       UWI_Location__c                = UWILocations[i].getId(),
                                                       Well__c                        = wells[i].getId(),
                                                       Target_Location__c             = targetLocations[i].getId(),
                                                       RecordTypeId = rt.Id,
                                                       Geologist__c                   = 'Mike',
                                                       Reservoir_Engineer__c          = 'Mike',
                                                       Construction_Superintendent__c = 'Mike',
                                                       Drilling_Superintendent__c     = 'Mike',
                                                       Completion_Superintendent__c   = 'Mike',
                                                       Facilities_Engineer__c         = 'Mike');
            boreholes.add(bore);
            counter++;
        }
        return Database.insert(boreholes);
    }
    
    public static List<Map<String, Database.saveResult>> createProjects(Integer counter, List<Database.saveResult> boreholes)
    {
        List<Map<String, Database.saveResult>> allProjects = new List<Map<String, Database.saveResult>>();
        
        List<Milestone1_Project__c> projects = new List<Milestone1_Project__c>();
        
        for(Integer i = 0; i < boreholes.size(); i++)
        {
            Milestone1_Project__c drilling = new Milestone1_Project__c(Name            = 'Drilling '+counter,
                                                                       GRD_Borehole__c = boreholes[i].getId());
            projects.add(drilling);
            
            Milestone1_Project__c completion = new Milestone1_Project__c(Name            = 'Completion '+counter,
                                                                         GRD_Borehole__c = boreholes[i].getId());
            projects.add(completion);
            
            Milestone1_Project__c tiein = new Milestone1_Project__c(Name            = 'Tie In '+counter,
                                                                    GRD_Borehole__c = boreholes[i].getId());
            projects.add(tiein);
            
            Milestone1_Project__c facilityequip = new Milestone1_Project__c(Name            = 'Facility Equipment '+counter,
                                                                            GRD_Borehole__c = boreholes[i].getId());
            projects.add(facilityequip);
            
            counter++;
        }
        
        List<Database.saveResult> projectsResult = Database.insert(projects);
        
        List<GRD_Borehole__c> boresToUpdate = new List<GRD_Borehole__c>();
        
        Integer boreIndex    = 0;
        Integer projectIndex = 0;
        for(; boreIndex < boreholes.size(); boreIndex++)
        {
            boresToUpdate.add(new GRD_Borehole__c(Id                            = boreholes[boreIndex].getId(),
                                                  Drilling_Project__c           = projectsResult[projectIndex].getId(),
                                                  Completion_Project__c         = projectsResult[projectIndex+1].getId(),
                                                  Tie_In_Project__c             = projectsResult[projectIndex+2].getId(),
                                                  Facility_Equipment_Project__c = projectsResult[projectIndex+3].getId()));
            
            Map<String, Database.saveResult> projectGroup = new Map<String, Database.saveResult>();
            projectGroup.put('Drilling',             projectsResult[projectIndex]);
            projectGroup.put('Completion',           projectsResult[projectIndex+1]);
            projectGroup.put('Tie In',               projectsResult[projectIndex+2]);
            projectGroup.put('Facility & Equipment', projectsResult[projectIndex+3]);
            allProjects.add(projectGroup);
            
            projectIndex+=4;
        }
        
        update boresToUpdate;
        
        return allProjects;
    }
    
    public static List<Map<String, Database.saveResult>> createBudgets(Integer counter, List<Map<String, Database.saveResult>> projects)
    {
        List<Map<String, Database.saveResult>> allBudgets = new List<Map<String, Database.saveResult>>();
        
        List<Class_C_Budget_Capital__c> budgets  = new List<Class_C_Budget_Capital__c>();
        
        for(Integer i = 0; i < projects.size(); i++)
        {
            // Budgets
            Class_C_Budget_Capital__c drillingBudget = new Class_C_Budget_Capital__c(Name                       = 'Drilling Budget '+counter,
                                                                                     Project__c                 = projects[i].get('Drilling').getId(),
                                                                                     Year__c                    = 2014,
                                                                                     Capital_Cost_Wells_GUID__c = 'Drilling Budget '+counter);
            budgets.add(drillingBudget);
            
            Class_C_Budget_Capital__c completionBudget = new Class_C_Budget_Capital__c(Name                       = 'Completion Budget '+counter,
                                                                                       Project__c                 = projects[i].get('Completion').getId(),
                                                                                       Year__c                    = 2014,
                                                                                       Capital_Cost_Wells_GUID__c = 'Completion Budget '+counter);
            budgets.add(completionBudget);
            
            
            Class_C_Budget_Capital__c tieinBudget = new Class_C_Budget_Capital__c(Name                       = 'Tie In Budget '+counter,
                                                                                  Project__c                 = projects[i].get('Tie In').getId(),
                                                                                  Year__c                    = 2014,
                                                                                  Capital_Cost_Wells_GUID__c = 'Tie In Budget '+counter);
            budgets.add(tieinBudget);
            
            Class_C_Budget_Capital__c facilityequipBudget = new Class_C_Budget_Capital__c(Name                       = 'Facility Equip Budget '+counter,
                                                                                          Project__c                 = projects[i].get('Facility & Equipment').getId(),
                                                                                          Year__c                    = 2014,
                                                                                          Capital_Cost_Wells_GUID__c = 'Facility Equip Budget '+counter);
            budgets.add(facilityequipBudget);
            
            counter++;
        }
        
        List<Database.saveResult> budgetsResult = Database.insert(budgets);
        
        List<Milestone1_Project__c> projectsToUpdate = new List<Milestone1_Project__c>();
        
        Integer projectIndex = 0;
        Integer budgetIndex  = 0;
        for(; projectIndex < projects.size(); projectIndex++)
        {
            Map<String, Database.saveResult> budgetGroup = new Map<String, Database.saveResult>();
            budgetGroup.put('Drilling',             budgetsResult[budgetIndex  ]);
            budgetGroup.put('Completion',           budgetsResult[budgetIndex+1]);
            budgetGroup.put('Tie In',               budgetsResult[budgetIndex+2]);
            budgetGroup.put('Facility & Equipment', budgetsResult[budgetIndex+3]);
            allBudgets.add(budgetGroup);
            
            projectsToUpdate.add(new Milestone1_Project__c(Id                = projects[projectIndex].get('Drilling').getId(),
                                                           Current_Budget__c = budgetsResult[budgetIndex].getId()));
            
            projectsToUpdate.add(new Milestone1_Project__c(Id                = projects[projectIndex].get('Completion').getId(),
                                                           Current_Budget__c = budgetsResult[budgetIndex+1].getId()));
            
            projectsToUpdate.add(new Milestone1_Project__c(Id                = projects[projectIndex].get('Tie In').getId(),
                                                           Current_Budget__c = budgetsResult[budgetIndex+2].getId()));
            
            projectsToUpdate.add(new Milestone1_Project__c(Id                = projects[projectIndex].get('Facility & Equipment').getId(),
                                                           Current_Budget__c = budgetsResult[budgetIndex+3].getId()));
            
            budgetIndex += 4;
        }
        
        update projectsToUpdate;
        
        return allBudgets;
    }
    
    public static void createIncompleteTestData(String counter)
    {
        //===============================================
        //   Create some wells, locations, and budgets
        //===============================================
        
        // Well
        GRD_Well__c well1 = new GRD_Well__c(Name = 'Well '+counter);
        Database.saveResult well1Result = Database.insert(well1);
        
        // Get GRD's recordtype
        RecordType rt = [SELECT Id FROM RecordType where sobjecttype = 'GRD_Borehole__c' and DeveloperName = 'GRD'];
        
system.debug('harjit '+rt);
        
        // Borehole
        GRD_Borehole__c bore1 = new GRD_Borehole__c(Name = 'Borehole '+counter,RecordTypeId = rt.Id);
        Database.saveResult bore1Result = Database.insert(bore1);
        
system.debug('harjit '+bore1);
    }
    
    public static List<Database.saveResult> createPartners(Integer num, Integer counter, Database.saveResult borehole)
    {
        List<Well_Partner__c> partners = new List<Well_Partner__c>();
        
        Integer stop = counter+num;
        for(; counter < stop; counter++)
        {
            Well_Partner__c partner = new Well_Partner__c(Name            = 'Partner '+counter,
                                                          GRD_Borehole__c = borehole.getId(),
                                                          Partner__c      = 'Partner '+counter,
                                                          Percentage__c   = .01);
            partners.add(partner);
        }
        return Database.insert(partners);
    }
    
    //===========================================================
    //   Test page with wells that are missing related records
    //===========================================================

    @isTest (SeeAllData = false)
    static void test_well_with_related_objects()
    {
         User grdIntegration = [SELECT Id FROM User WHERE UserName='grd.dataloader@huskyenergy.com'];
        
        System.runAs(grdIntegration)
        {
            
            // Create test data
            
            // Business Dept
            Database.saveResult dept = createBusinessDept('1');
            
            // 1 District
            Database.saveResult district = createDistrict('1', dept);
            
            // 2 Fields
            List<Database.saveResult> AMUs = createAMUs(2, 1, district);
            
            // 20 location groups
            List<Map<String, Database.saveResult>> locations1 = createLocations(10, 1, AMUs[0]);
            List<Map<String, Database.saveResult>> locations2 = createLocations(10, 11, AMUs[1]);
            
            List<Database.saveResult> surfaceLocations1 = new List<Database.saveResult>();
            List<Database.saveResult> targetLocations1  = new List<Database.saveResult>();
            List<Database.saveResult> UWILocations1     = new List<Database.saveResult>();
            for(Map<String, Database.saveResult> locationGroup : locations1)
            {
                surfaceLocations1.add(locationGroup.get('Surface'));
                targetLocations1.add(locationGroup.get('Target'));
                UWILocations1.add(locationGroup.get('UWI'));
            }
            
            List<Database.saveResult> surfaceLocations2 = new List<Database.saveResult>();
            List<Database.saveResult> targetLocations2  = new List<Database.saveResult>();
            List<Database.saveResult> UWILocations2     = new List<Database.saveResult>();
            for(Map<String, Database.saveResult> locationGroup : locations2)
            {
                surfaceLocations2.add(locationGroup.get('Surface'));
                targetLocations2.add(locationGroup.get('Target'));
                UWILocations2.add(locationGroup.get('UWI'));
            }
            
            // 20 wells
            List<Database.saveResult> wells1 = createWells(10, 1, surfaceLocations1);
            List<Database.saveResult> wells2 = createWells(10, 11, surfaceLocations2);
            
            // 20 boreholes
            List<Database.saveResult> boreholes1 = createBoreholes(1, wells1, targetLocations1, UWILocations1);
            List<Database.saveResult> boreholes2 = createBoreholes(11, wells2, targetLocations2, UWILocations2);
            
            List<Database.saveResult> allBoreholes = new List<Database.saveResult>();
            for(Database.saveResult borehole : boreholes1)
                allBoreholes.add(borehole);
            for(Database.saveResult borehole : boreholes2)
                allBoreholes.add(borehole);
            
            // 20 project groups
            List<Map<String, Database.saveResult>> projects = createProjects(1, allBoreholes);
            
            // 20 budget groups
            List<Map<String, Database.saveResult>> budgets = createBudgets(1, projects);
            
            Test.startTest();
        
            
            PageReference WCPWells = Page.WCPWells;
            WCPWells.getParameters().put('show', 'Gas Resource Development');
            Test.setCurrentPage(WCPWells);
            WellExtensionController controller = new WellExtensionController();
            
            WellExtensionController.findWells('Borehole');
            controller.searchString = 'Borehole';
            controller.searchWells();
            
            controller.searchString = null;
            controller.viewWells();
            
            //=====================================//
            //   Test the GRD Dashbard Home page   //
            //=====================================//
            
            // There should be 20 wells we can fetch
            
            //System.assertEquals(20,controller.mySetController.getResultSize());
            
            // We're displaying 20 in the list
            
           // System.assertEquals(20,controller.getWells().size());
            
            // Change to display 10
            
            controller.setWellsPerPage('10');
            controller.viewWells();
            //System.assertEquals(10,controller.getWells().size());
            //System.assertEquals('10',controller.getWellsPerPage());
            
            // Click Next
            
            //System.assert(controller.mySetController.getHasNext());
            controller.mySetController.next();
            //System.assertEquals(2,controller.mySetController.getPageNumber());
            
            // Click Previous
            
            //System.assert(controller.mySetController.getHasPrevious());
            controller.mySetController.previous();
            //System.assertEquals(1,controller.mySetController.getPageNumber());
            
            // Click Last
            
            controller.mySetController.last();
            //System.assertEquals(2,controller.mySetController.getPageNumber());
            
            // Click First
            
            controller.mySetController.first();
            controller.mySetController.previous();
            //System.assertEquals(1,controller.mySetController.getPageNumber());
            
            // Sort by all the possible fields
            
            controller.sortWells();
            controller.sortField = 'Surface Location';
            controller.sortWells();
            controller.sortWells();
            controller.sortField = 'Target Formation';
            controller.sortWells();
            controller.sortWells();
            controller.sortField = 'Well Class';
            controller.sortWells();
            controller.sortWells();
            controller.sortField = 'Well Orientation';
            controller.sortWells();
            controller.sortWells();
            controller.sortField = 'License Number';
            controller.sortWells();
            controller.sortWells();
            controller.sortField = 'Budget Year';
            controller.sortWells();
            controller.sortWells();
            
            // Search for 'Borehole 5', only one should show up
            
            controller.searchString = 'Borehole 5';
            controller.viewWells();
            //gunasd : This was 1 but not sure why. 'Borehole 5' attached to 10 wells, so it should return 10 records
            //System.assertEquals(10,controller.getWells().size());
            
            controller.homeSearchWells();
            
            controller.searchString = '';
            
            // Change to display all wells, there should be no wells displayed
            
            controller.wellView = 'wellsimfollowing';
            controller.viewWells();
            //System.assertEquals(0,controller.getWells().size());
            
            // Follow Well 'Borehole 15'
            
            
            
            
            
            
            
            
            // Reload page, make sure 'Borehole 15' is there
            
            controller.viewWells();
            
            // Test remaining functionality (mainly getter/setter stuff)
            controller.getWellsPerPageOptions();
            controller.getListviewoptions();
///////        homeSearchWells();      IS THIS EVEN USED STILL????

            Test.stopTest();
        }
    }

    //===================================================================
    //   Test page with wells that are have incomplete related records
    //===================================================================
    @isTest (SeeAllData = false)
    static void test_well_without_related_objects()
    {
         User grdIntegration = [SELECT Id FROM User WHERE UserName='grd.dataloader@huskyenergy.com'];
        
        System.runAs(grdIntegration)
        {
            for(Decimal i = 0; i < 50; i++)
            {
                createIncompleteTestData(String.valueOf(i));
            }
            
            Test.startTest();
            
            PageReference WCPWells = Page.WCPWells;
            Test.setCurrentPage(WCPWells);
            WellExtensionController controller = new WellExtensionController();
            
            //=====================================//
            //   Test the GRD Dashbard Home page   //
            //=====================================//
            
            // There should be 75 wells we can fetch
            
            //System.assertEquals(50,controller.mySetController.getResultSize());
            
            // But we're displaying 20 in the list
            
           // System.assertEquals(20,controller.getWells().size());
            
            // Change to display 10
            
            controller.setWellsPerPage('10');
            controller.viewWells();
            //System.assertEquals(10,controller.getWells().size());
            
            // Click Next
            
            //System.assert(controller.mySetController.getHasNext());
            controller.mySetController.next();
            //System.assertEquals(2,controller.mySetController.getPageNumber());
            
            // Click Previous
            
            //System.assert(controller.mySetController.getHasPrevious());
            controller.mySetController.previous();
            //System.assertEquals(1,controller.mySetController.getPageNumber());
            
            // Click Last
            
            controller.mySetController.last();
///            System.assertEquals(8,controller.mySetController.getPageNumber());
            
            // Click First
            
            controller.mySetController.first();
            controller.mySetController.previous();
            //System.assertEquals(1,controller.mySetController.getPageNumber());
            
            // Sore by Name in reverse
            
            controller.sortField = 'Name';
            controller.sortWells();
            
            // Search for 'Borehole 15', only one should show up
            
            
            
            // Change to display all wells, there should be no wells displayed
            
            controller.wellView = 'wellsimfollowing';
            controller.viewWells();
            //System.assertEquals(0,controller.getWells().size());
            
            // Follow Well 'Borehole 25'
            
            // Reload page, make sure 'Borehole 25' is there
            
            controller.viewWells();
            
            Test.stopTest();
        }
    }

    @isTest (SeeAllData = false)
    static void test_borehole_page()
    {
        List<Database.saveResult> borehole;
        
        User grdIntegration = [SELECT Id FROM User WHERE UserName='grd.dataloader@huskyenergy.com'];
        
        System.runAs(grdIntegration)
        {
            // Create test data
            
            // Business Dept
            Database.saveResult dept = createBusinessDept('1');
            
            // 1 District
            Database.saveResult district = createDistrict('1', dept);
            
            // 1 Field
            Database.saveResult AMU = createAMU('1', district);
            
            // 1 location group
            List<Map<String, Database.saveResult>> locations = createLocations(1, 1, AMU);
            
            List<Database.saveResult> surfaceLocation = new List<Database.saveResult>();
            List<Database.saveResult> targetLocation  = new List<Database.saveResult>();
            List<Database.saveResult> UWILocation     = new List<Database.saveResult>();
            for(Map<String, Database.saveResult> locationGroup : locations)
            {
                surfaceLocation.add(locationGroup.get('Surface'));
                targetLocation.add(locationGroup.get('Target'));
                UWILocation.add(locationGroup.get('UWI'));
            }
            
            // 1 well
            List<Database.saveResult> well = createWells(1, 1, surfaceLocation);
            
            // 1 borehole
            borehole = createBoreholes(1, well, targetLocation, UWILocation);
                    
            // 1 project group
            List<Map<String, Database.saveResult>> projects = createProjects(1, borehole);
            
            // 1 budget group
            List<Map<String, Database.saveResult>> budgets = createBudgets(1, projects);
            
            Test.startTest();
            
            ApexPages.StandardController sc = new ApexPages.StandardController(new GRD_Borehole__c(Id = borehole[0].getId()));
            
            PageReference GRDDashboard = Page.GRDDashboard;
            GRDDashboard.getParameters().put('id', borehole[0].getId());
            Test.setCurrentPage(GRDDashboard);
            
            WellExtensionController controller = new WellExtensionController(sc);
            
            //================================//
            //   Test the GRD Dashbard page   //
            //================================//
            
            Test.stopTest();
        }
    }
    
    @isTest (SeeAllData = false)
    static void testGRDDashboard()
    {
        List<Database.saveResult> boreholes;
        
         User grdIntegration = [SELECT Id FROM User WHERE UserName='grd.dataloader@huskyenergy.com'];
        
        System.runAs(grdIntegration)
        {
        
            // Create test data
            
            // Business Dept
            Database.saveResult dept = createBusinessDept('1');
            
            // 1 District
            Database.saveResult district = createDistrict('1', dept);
            
            // 1 Fields
            List<Database.saveResult> AMUs = createAMUs(1, 1, district);
            
            // 1 location groups
            List<Map<String, Database.saveResult>> locations = createLocations(1, 1, AMUs[0]);
            
            List<Database.saveResult> surfaceLocations = new List<Database.saveResult>();
            List<Database.saveResult> targetLocations  = new List<Database.saveResult>();
            List<Database.saveResult> UWILocations     = new List<Database.saveResult>();
            for(Map<String, Database.saveResult> locationGroup : locations)
            {
                surfaceLocations.add(locationGroup.get('Surface'));
                targetLocations.add(locationGroup.get('Target'));
                UWILocations.add(locationGroup.get('UWI'));
            }
            
            // Well
            List<Database.saveResult> wells = createWells(1, 1, surfaceLocations);
            
            // Borehole
            boreholes = createBoreholes(1, wells, targetLocations, UWILocations);
            
            // Projects
            List<Map<String, Database.saveResult>> projects = createProjects(1, boreholes);
            
            // Budgets
            List<Map<String, Database.saveResult>> budgets = createBudgets(1, projects);
            
            Test.startTest();
            
            PageReference GRDDashboard = Page.GRDDashboard;
            GRDDashboard.getParameters().put('Id',boreholes[0].getId());
            Test.setCurrentPage(GRDDashboard);
            WellExtensionController controller = new WellExtensionController();
            
            //================================//
            //   Test the GRD Dashbard page   //
            //================================//
            
            
            
        
        
            Test.stopTest();
        }
    }
    
    @isTest (SeeAllData = false)
    static void testWellPartnerController()
    {
        List<Database.saveResult> boreholes;
        
        User grdIntegration = [SELECT Id FROM User WHERE UserName='grd.dataloader@huskyenergy.com'];
        
        System.runAs(grdIntegration)
        {
            // Create test data
            
            // Business Dept
            Database.saveResult dept = createBusinessDept('1');
            
            // 1 District
            Database.saveResult district = createDistrict('1', dept);
            
            // 2 Fields
            List<Database.saveResult> AMUs = createAMUs(1, 1, district);
            
            // 1 location group
            List<Map<String, Database.saveResult>> locations = createLocations(1, 1, AMUs[0]);
            
            List<Database.saveResult> surfaceLocations = new List<Database.saveResult>();
            List<Database.saveResult> targetLocations  = new List<Database.saveResult>();
            List<Database.saveResult> UWILocations     = new List<Database.saveResult>();
            for(Map<String, Database.saveResult> locationGroup : locations)
            {
                surfaceLocations.add(locationGroup.get('Surface'));
                targetLocations.add(locationGroup.get('Target'));
                UWILocations.add(locationGroup.get('UWI'));
            }
            
            // Well
            List<Database.saveResult> wells = createWells(1, 1, surfaceLocations);
            
            // Borehole
            boreholes = createBoreholes(1, wells, targetLocations, UWILocations);
            
            // Projects
            List<Map<String, Database.saveResult>> projects = createProjects(1, boreholes);
            
            // Budgets
            List<Map<String, Database.saveResult>> budgets = createBudgets(1, projects);
            
            // Partners
            List<Database.saveResult> partners = createPartners(10, 1, boreholes[0]);
            
            Test.startTest();
            
            PageReference WellPartners = Page.WellPartners;
            WellPartners.getParameters().put('Id',boreholes[0].getId());
            Test.setCurrentPage(WellPartners);
            
            WellPartnersController controller = new WellPartnersController();
            
            // There should be 10 partners
            //System.assertEquals(10, controller.partners.size());
            
            // Sort by various columns
            controller.sortPartners(); // reverse sort on Name
            
            controller.sortField = 'Effective';
            controller.sortPartners(); // sort on Effective
            controller.sortPartners(); // reverse sort on Effective
            
            controller.sortField = 'Expiry';
            controller.sortPartners(); // sort on Expiry
            controller.sortPartners(); // reverse sort on Expiry
            
            controller.sortField = 'Percentage';
            controller.sortPartners(); // sort on Percentage
            controller.sortPartners(); // reverse sort on Percentage
            
            Test.stopTest();
        }
    }
    
    @isTest (SeeAllData = false)
    static void testGRDFilterController()
    {
        User grdIntegration = [SELECT Id FROM User WHERE UserName='grd.dataloader@huskyenergy.com'];
        
        System.runAs(grdIntegration)
        {
            // Create test data
            
            // Business Dept
            Database.saveResult dept = createBusinessDept('1');
            
            // 1 District
            Database.saveResult district = createDistrict('1', dept);
            
            // 2 Fields
            List<Database.saveResult> AMUs = createAMUs(2, 1, district);
            
            // 20 location groups
            List<Map<String, Database.saveResult>> locations1 = createLocations(10, 1, AMUs[0]);
            List<Map<String, Database.saveResult>> locations2 = createLocations(10, 11, AMUs[1]);
            
            List<Database.saveResult> surfaceLocations1 = new List<Database.saveResult>();
            List<Database.saveResult> targetLocations1  = new List<Database.saveResult>();
            List<Database.saveResult> UWILocations1     = new List<Database.saveResult>();
            for(Map<String, Database.saveResult> locationGroup : locations1)
            {
                surfaceLocations1.add(locationGroup.get('Surface'));
                targetLocations1.add(locationGroup.get('Target'));
                UWILocations1.add(locationGroup.get('UWI'));
            }
            
            List<Database.saveResult> surfaceLocations2 = new List<Database.saveResult>();
            List<Database.saveResult> targetLocations2  = new List<Database.saveResult>();
            List<Database.saveResult> UWILocations2     = new List<Database.saveResult>();
            for(Map<String, Database.saveResult> locationGroup : locations2)
            {
                surfaceLocations2.add(locationGroup.get('Surface'));
                targetLocations2.add(locationGroup.get('Target'));
                UWILocations2.add(locationGroup.get('UWI'));
            }
            
            // 20 wells
            List<Database.saveResult> wells1 = createWells(10, 1, surfaceLocations1);
            List<Database.saveResult> wells2 = createWells(10, 11, surfaceLocations2);
            
            // 20 boreholes
            List<Database.saveResult> boreholes1 = createBoreholes(1, wells1, targetLocations1, UWILocations1);
            List<Database.saveResult> boreholes2 = createBoreholes(11, wells2, targetLocations2, UWILocations2);
            
            List<Database.saveResult> allBoreholes = new List<Database.saveResult>();
            for(Database.saveResult borehole : boreholes1)
                allBoreholes.add(borehole);
            for(Database.saveResult borehole : boreholes2)
                allBoreholes.add(borehole);
            
            // 20 project groups
            List<Map<String, Database.saveResult>> projects = createProjects(1, allBoreholes);
            
            // 20 budget groups
            List<Map<String, Database.saveResult>> budgets = createBudgets(1, projects);
            
            Test.startTest();
            
            PageReference GRDFilter = Page.GRDFilter;
            GRDFilter.getParameters().put('field','Budget_Year');
            GRDFilter.getParameters().put('value','2014');
            Test.setCurrentPage(GRDFilter);
            
            GRDFilterController controller = new GRDFilterController();
            
            // Make sure we grabbed all boreholes we wanted.
            //System.assertEquals(20, controller.getWells().size());
            
            // Sort by various fields
            controller.sortWells();
            
            controller.sortField = 'Surface Location';
            controller.sortWells();
            controller.sortWells();
            
            controller.sortField = 'Target Formation';
            controller.sortWells();
            controller.sortWells();
            
            controller.sortField = 'Well Class';
            controller.sortWells();
            controller.sortWells();
            
            controller.sortField = 'License Number';
            controller.sortWells();
            controller.sortWells();
            
            controller.sortField = 'Budget Year';
            controller.sortWells();
            controller.sortWells();
            
            
            GRDFilter = Page.GRDFilter;
            GRDFilter.getParameters().put('field','Contact');
            GRDFilter.getParameters().put('value','Mike');
            Test.setCurrentPage(GRDFilter);
            
            controller = new GRDFilterController();
            
            // Make sure we grabbed all boreholes we wanted.
            //System.assertEquals(20, controller.getWells().size());
            controller.sortWells();
            
            Test.stopTest();
        }
    }
    
    @isTest (SeeAllData = false)
    static void testGRDWellGantt()
    {
        List<Database.saveResult> boreholes;
        
         User grdIntegration = [SELECT Id FROM User WHERE UserName='grd.dataloader@huskyenergy.com'];
        
        System.runAs(grdIntegration)
        {
            // Create test data
            
            // Business Dept
            Database.saveResult dept = createBusinessDept('1');
            
            // 1 District
            Database.saveResult district = createDistrict('1', dept);
            
            // 2 Fields
            List<Database.saveResult> AMUs = createAMUs(1, 1, district);
            
            // 15 location groups
            List<Map<String, Database.saveResult>> locations = createLocations(1, 1, AMUs[0]);
            
            List<Database.saveResult> surfaceLocations = new List<Database.saveResult>();
            List<Database.saveResult> targetLocations  = new List<Database.saveResult>();
            List<Database.saveResult> UWILocations     = new List<Database.saveResult>();
            for(Map<String, Database.saveResult> locationGroup : locations)
            {
                surfaceLocations.add(locationGroup.get('Surface'));
                targetLocations.add(locationGroup.get('Target'));
                UWILocations.add(locationGroup.get('UWI'));
            }
            
            // Well
            List<Database.saveResult> wells = createWells(1, 1, surfaceLocations);
            
            // Borehole
            boreholes = createBoreholes(1, wells, targetLocations, UWILocations);
            
            // Projects
            List<Map<String, Database.saveResult>> projects = createProjects(1, boreholes);
            
            // Budgets
            List<Map<String, Database.saveResult>> budgets = createBudgets(1, projects);
            
            Test.startTest();
            
            PageReference GRDWellGantt = Page.GRDWellGantt;
            GRDWellGantt.getParameters().put('Id',boreholes[0].getId());
            Test.setCurrentPage(GRDWellGantt);
            
            Test.stopTest();
        }
    }
}